import random
import my_random


# returns longest, sequence on left, sequence on right
def longest_negative_sequence_dichotomic_with_bounds(t, begin, end):
    if end-begin == 0:
        longest = 0, begin
        return longest, longest, longest
    if end-begin == 1:
        if t[begin] < 0:
            return (1, begin), (1, begin), (1, begin)
        else:
            return (0, begin), (0, begin), (0, end)
    middle = (begin+end)//2
    lefts = longest_negative_sequence_dichotomic_with_bounds(t, begin, middle)
    rights = longest_negative_sequence_dichotomic_with_bounds(t, middle, end)
    # sequence on middle is merging right seq on left and left sequence on right
    seq_middle = lefts[2][0]+rights[1][0], lefts[2][1]
    # get maximum of the 3!
    if lefts[0][0] >= rights[0][0]:
        max = lefts[0]
    else:
        max = rights[0]
    if max[0] < seq_middle[0] or (max[0] == seq_middle[0] and seq_middle[1] < max[1]):
        max = seq_middle
    # construct the left
    if max[1] == begin:
        left = max
    else:
        left = lefts[1]
    # construct the right
    if max[1]+max[0] == end:
        right = max
    else:
        right = rights[2]
    return max, left, right


def longest_negative_sequence_dichotomic(t):
    return longest_negative_sequence_dichotomic_with_bounds(t, 0, len(t))[0]


def lfp_dac(t, begin, end):
    if end-begin == 0:
        return 0, 0, 0
    if end-begin == 1:
        if t[begin] < 0:
            return 1, 1, 1
        else:
            return 0, 0, 0
    mid = (begin+end)//2
    l1, m1, r1 = lfp_dac(t, begin, mid)
    l2, m2, r2 = lfp_dac(t, mid, end)
    m = max(m1, m2, r1+l2)
    if l1 < mid-begin:
        l = l1
    else:
        l = mid-begin+l2
    if r2 < end-mid:
        r = r2
    else:
        r = end-mid+r1
    return l, m, r


def longest_negative_sequence_linear(t):
    final_result = (0, 0)
    if len(t) == 0:
        return final_result
    POSITIVE = 1
    NEGATIVE = 0
    state = POSITIVE
    length = 0
    start = 0
    for i in range(0, len(t)):
        if state == POSITIVE:
            if t[i] < 0:
                state = NEGATIVE
                start = i
        else:  # NEGATIVE
            if t[i] >= 0:
                state = POSITIVE
                length = i - start
                r = (length, start)
                if r[0] > final_result[0]:
                    final_result = r
    # we may end with a negative subsequence
    if state == NEGATIVE:
        length = len(t) - start
        r = (length, start)
        if r[0] > final_result[0]:
            final_result = r
    return final_result


for i in range(0,100000):
    t = my_random.random_temperatures(random.randint(0, 100))
    rl = longest_negative_sequence_linear(t)
    rd = longest_negative_sequence_dichotomic(t)
    rr = lfp_dac(t, 0, len(t))
    #print(rl, rd, rr)
    if rl != rd:
        print("Bad", rl, rd)
        exit()
    if rl[0] != rr[1]:
        print("Bad2", rl, rr)
print("Great")

